<?php
/*****************************************************************************
 PiXfr Photo Module (PPM)  Version 1.1.1
 Photo galleries generator
 -----------------------------------------------------------------------------
 core PPM file
 -----------------------------------------------------------------------------
 Copyright (c) 2000,2001 by Yann Courtaux (pixman@pixfr.com)
 http://pixfr.com

 This program is free software.
 You can redistribute it and/or modify it under the terms of the GNU General
 Public License as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details
 (attached file LICENSE).
******************************************************************************/

// Relative path of THE galleries directory (without / at the end)
define('PPM_REL_DIR',$ModDir.PPM_DIR);

// Absolute path of THE galleries directory (without / at the end)
define('PPM_ABS_DIR',_PN_DIR.PPM_REL_DIR);

// includes the current language file if found
if(file_exists($ModLangDir.'/'.$lang.PPM_EXT)) {
   include($ModLangDir.'/'.$lang.PPM_EXT);
// else includes the default language file
} elseif(file_exists($ModLangDir.'/'.$ppmLanguage.PPM_EXT)) {
     include($ModLangDir.'/'.$ppmLanguage.PPM_EXT);
     $lang = $ppmLanguage;
  } else {
      print('[ PPM ERROR ] Language file '.$ppmLanguage.PPM_EXT.' not found.'."\n");
      print('Check '.$ModLangDir.' dir or change default language $ppmLanguage = '.$ppmLanguage.' in config'.PPM_EXT);
      exit;
  }

// PPM functions
include($ModDir.'functions'.PPM_EXT);

/******************************************************************************
 M A I N
******************************************************************************/

/* Fake DataShit Panic Page */
if(($cat=='stakanovist')&&($ppmPanic)) {
   header('Location: '.$ModDir.'panic.html');
   exit;
}

/* Parameters check */

// SECURITY : do NOT remove !
if(!ppm_check_var($cat)) unset($cat);
if(!ppm_check_var($gal)) unset($gal);
if(!ppm_check_var($pic)) unset($pic);

// [1] $cat missing or wrong -> 'Categories' screen.
if ((!isset($cat))||(!is_dir(PPM_ABS_DIR.'/'.$cat))) {
   if(is_dir(PPM_ABS_DIR)) { // -> PPM_DIR found
      $cat_array = ppm_get_dirs(PPM_ABS_DIR);
      $catCount = $dirCount;
      $TRT = 1;
      unset($cat);
    }
    else $TRT = 0;// -> PPM_DIR missing
}

// [2] $cat OK but $gal missing or wrong -> List of the $cat galleries
elseif ((!isset ($gal)) || (!is_dir(PPM_ABS_DIR.'/'.$cat.'/'.$gal)) || ($gal=='')) {
   $galtab = ppm_get_dirs(PPM_ABS_DIR.'/'.$cat);
      if (is_array($galtab)) {
         while (list ($key, $val) = each ($galtab)) {
            $tn_array[] = ppm_get_thumb(PPM_ABS_DIR.'/'.$cat.'/'.$val,$ppmCat['random_thumb']);
            $tn_count[] = $TNCount;
         }
         $TRT=2;
      }
      else {
         $TRT=1.5;            // --> no gal
      }
   unset($gal);
}
// [3] $gal OK  --> Thumbs screen of gallery $cat/$gal
else {
   $TRT=3;
}

$path     = PPM_REL_DIR.'/'.$cat.'/'.$gal;

$separator = ' >> ';

// get icons
$sepdir  = MOD_IMG_DIR.'/ppm';
$sepsub  = '/'.$ppmColor['back'].'/'.$ppmColor['icon'];
if(!file_exists($sepdir.$sepsub)) {  // default grey icons
   $sepsub = '';
}
$sepdir = $sepdir.$sepsub;
if (file_exists($sepdir.'/sep.gif')) {
   $separator = '&nbsp;&nbsp;<img src="'.$sepdir.'/sep.gif" border="0" align="top">&nbsp;&nbsp;';
}

$ppm_refresh_url = $HTTP_SERVER_VARS["REQUEST_URI"];
$ppm_refresh_link = '<small> &nbsp; <a href="'.$ppm_refresh_url.'">['._MODpREFRESH.']</small></a>';

if (file_exists($sepdir.'/ref.gif')) {
     $ppm_refresh_link = '&nbsp;&nbsp;<a href="'.$ppm_refresh_url.'"><img src="'.$sepdir
     .'/ref.gif" border="0" align="top" alt="'._MODpREFRESH.'"></a>';
}

if($ppmMain['refresh']) {
   $ppm_main_refresh = $ppm_refresh_link;
} else {
   $ppm_main_refresh = '';
}

$link_ppm = ppm_rep_str(PPM_DIR).$ppm_main_refresh;

if ($TRT > 1) {
$lib_cat = PPM_DIR.$separator.ppm_rep_str($cat);
$lib_gal = $lib_cat.$separator.ppm_rep_str($gal);

if($ppmJpg)  ppm_get_images($path,'jpg');
if($ppmJpeg) ppm_get_images($path,'jpeg');
if($ppmPng)  ppm_get_images($path,'png');
if($ppmGif)  ppm_get_images($path,'gif');

$link_ppm = '<a href="'.PPMF.'">'.ppm_rep_str(PPM_DIR).'</a>';

if($ppmCat['refresh']) {
   $ppm_cat_refresh = $ppm_refresh_link;
} else {
   $ppm_cat_refresh = '';
}

   if (isset($gal)) {
      if (isset($pic)) {
         $link_gal  = '<small>'.$separator.'</small><a href="'.PPMF.PPMVAR.'cat='.$cat.'">'.ppm_rep_str($cat).'</a>';
         $link_gal .= '<small>'.$separator.'</small><a href="'.PPMF.PPMVAR.'cat='.$cat.'&amp;gal='.$gal.'">'
                      .ppm_rep_str($gal).'</a>'.$separator.ppm_rep_str($pic);
      }
      else {
         $link_gal  = '<small>'.$separator.'</small><a href="'.PPMF.PPMVAR.'cat='.$cat.'">'.ppm_rep_str($cat).'</a>'.$separator
                      .ppm_rep_str($gal);}
      }
   elseif (isset($cat)) {
      $link_cat = $separator.ppm_rep_str($cat).$ppm_cat_refresh;
   }
}

$link_menu = $link_ppm.$link_cat.$link_gal;
$NbImages = count($images);

/******************************************************************************
 P A G E    C O N S T R U C T I O N
******************************************************************************/

include('header'.$ppm_standalone.PPM_EXT);

OpenTable();

if($ppmPanic) {
   $panic = '<a href="'.PPMF.PPMVAR.'cat=stakanovist">'._MODpPANICTEXT.'</a>';
}
else {
   $panic = '';
}

print("\n");

ppm_rem(_MODpPOWEREDBY.' PiXfr Photo Module '.PPM_VERSION);

print("\n");

print('<table align="center" width="100%" summary="liens">'."\n".' <tr><td align="left" nowrap>'."\n"
     .'  <H3>'.$link_menu.'</H3>'."\n".' </td><td align="right"><h4>'.$panic."</h4>\n".' </td></tr>'."\n"
     .'</table>'."\n\n");

   if (isset($pic)) { // -> Image screen.
      $src = $path.'/'.$pic;
      print("\n".'<table align="center" border="0" summary="Picture">'."\n".' <tr><td align="center">'."\n");
      ppm_do_links($images, 'pic');
      print("\n".' </td></tr><tr><td align="center">'."\n");
      $ppm_pic_text = '';
      if($ppmText) {
         $ppm_pic_text = ppm_get_text('/'.$cat.'/'.$gal,$pic);
         if(($ppm_pic_text>' ')&&($ppmPic['text_at_top']==1)) {
           print('<br>');
           ppm_message($ppm_pic_text);
           print('<br>');
         }
      }
      $img_size = @GetImageSize($path.'/'.$pic);
         if(@count($img_size)>1) {
            $img_parms = 'width="'.$img_size[0].'" height="'.$img_size[1].'" ';
         }
         else {
            $img_parms = '';
         }
      print('  <img src="'.$src.'" '.$img_parms.'alt="'.$pic.'" border="0"><br>');
      if(($ppm_pic_text>' ')&&($ppmPic['text_at_top']==0)) {
         print('<br>');
         ppm_message($ppm_pic_text);
      }
      print(' </td></tr>'."\n".'</table>'."\n");
      $screen='pic';
   }
   elseif (isset($gal)) { //$pic not set -> Thumbs screen.
      if (($TRT > 1) && ($NbImages!=0 )) {
        if($ppmGd['generate']) {
           if(ppm_root($path)) {
              $ppm_tn_process = 1;
              $ThumbErrNoRoot = 'OK';
           } else {
              $ppm_tn_process = 0;
              $ThumbErrNoRoot = "Directory permissions must be set to 777 to create TN<br>
                          You have to change them or turn off TN generation<br>";
           }
         }
         while (list($key, $fileName) = each($images)) {
               if(!empty($fileName)) {
                  $name_f = $path."/".$fileName;
                  $name_th = $name_f.'-ppm';
                     // buid the thumbnail if not found
                     $tn_ok=true;
                     if(!file_exists($name_th)) {
                        if($ppm_tn_process==1)
                        {   $ThumbResult = ppm_do_thumb($name_f,$name_th,$ppmGd['tnheight']);
                            if ($ThumbResult != 'OK') {
                               $ThumbErr[] = $fileName.' : '.$ThumbResult;
                               $tn_ok=false;
                            }
                        }
                        else {
                           $miss++;
                           $tn_ok=false;
                        }
                     }
                     if($tn_ok) {
                        $Fname[] = $fileName;
                        $Tname[] = $name_th;
                          $TNsize = @GetImageSize($name_th);
                          $TnW[]  = $TNsize[0];
                          $TnH[]  = $TNsize[1];
                     }
               }
         }

            if($ppmGal['info']) {
               $lib_picture = _MODpPICTURES;
               if ($NbImages == 1) {
                  $lib_picture = _MODpPICTURE;
               }
               $ppm_galinfo = ucfirst(_MODpGALLERY).' '.ppm_rep_str($gal).' - '.count($Tname).' '.$lib_picture
                              .'<br>';
            }
            if($ppmText) {
               $ppm_gal_text = ppm_get_text('/'.$cat.'/'.$gal,'ppm_text');
            }
         ppm_message($ppm_galinfo);
            if(($ppm_galinfo)&&($ppm_gal_text)) {
               print('<br>');
            }
         ppm_message($ppm_gal_text);
         print('<br>');
         ppm_rem('ThumbsTable BEGIN');
         print('<TABLE cellspacing="0" border="0" cellpadding="0" align="center" summary="Thumbs MainTable">'
              ."\n".' <TR><TD align="center">'."\n");
         print(' <Table width="1%" border="0" cellspacing="10" cellpadding="0" align="center"'
              .' summary="Thumbs SecondTable">'."\n".'  <Tr><Td align="center">');

         $count = 1;
         $TotalWidth = 0;
         $tn_columns = ppm_cols(count($Fname),$ppmMaxCols);
         $break = $tn_columns;

         if(is_array($Fname)) {
            while (list($key, $fileName) = each($Fname)) {
                  $TotalWidth += $TnW[$key];
                  if(($TotalWidth + $TnW[$key+1]) > $ppmMaxWidth) $break = $count;
                  $pic_link = PPMF.PPMVAR.'cat='.$cat.'&amp;gal='.$gal.'&amp;pic='.$fileName;
                  print('   <table align="center" border="0" cellspacing="0" width="10" summary="Thumb">'."\n");
                  print('    <tr><td align="center">'."\n");
                  print('     <a href="'.PPMF.PPMVAR.'cat='.$cat.'&amp;gal='.$gal.'&amp;pic='.$fileName.'">');
                  print("\n".'     <IMG SRC="'.$Tname[$key].'" border="0" alt="'.$fileName.'" width="'
                        .$TnW[$key].'" height="'.$TnH[$key].'"></a>'."\n");
                  print('    </td></tr>'."\n");
                  if(PPMDBG) print($TotalWidth);
                  // comments
                  if($ppmGal['img_number']) {
                     $ImgNumber = ($key+1);
                  } else $ImgNumber = '';
                  if($ppmGal['img_name']) {
                     $ImgName = ppm_rep_str($fileName);
                  } else $ImgName = '';
                  if($ImgNumber&&$ImgName) {
                     $Spacer = '&nbsp;&nbsp;';
                  } else $Spacer = '';
                  if($ppmGal['img_resolution']) {
                     $ImgResAr = GetImageSize($path.'/'.$fileName);
                     $ImgRes = $ImgResAr[0].'x'.$ImgResAr[1];
                  } else $ImgRes = '';
                  if($ppmGal['img_size']) {
                     $ImgSize = round((filesize($path.'/'.$fileName))/1024) . 'K';
                     if($ImgRes>' ') $ImgSize = ' - '.$ImgSize;
                  } else $ImgSize = '';
                  if(($ImgRes.$ImgSize) > ' ') {
                     $ImgProp = '['.$ImgRes.$ImgSize.']';
                  }
                  if($ppmGal['img_number']&&$ppmGal['img_name']) {
                     $ImgLineSep = '&nbsp;&nbsp;';
                  } else {
                     $ImgLineSep = '';
                  }
                  if($ppmGal['img_newline']) {
                     $NewLine = '    </td></tr><tr><td '.$ppm_class_text_s.'align="center" nowrap>';
                     $nowrap = '';
                  } else {
                     $NewLine = ' ';
                     $nowrap = ' nowrap';
                  }
                  if(($ImgProp.$ImgSize.$ImgName.$ImgNumber) > ' ') {
                     print('    <tr><td '.$ppm_class_text_s.'align="center"'.$nowrap.'><a '.$ppm_class_link_s.'href="'.$pic_link.'">'
                          .$ImgNumber.$ImgLineSep.$ImgName.'</a>'.$NewLine.$ImgProp."\n"
                          .'    </td></tr>'."\n");
                  }

                  print('   </table>'."\n");
                     if($count < count($images))
                     {  if($count == $break)
                        {  print('  </Td></Tr>'."\n".' </Table>'."\n");
                           print(' <Table border="0" cellspacing="10" cellpadding="0"'
                                .' align="center" summary="Thumbs SecondTableNext">'."\n");
                           print('  <Tr><Td align="center">'."\n");
                           $break = $count + $tn_columns;
                           $TotalWidth = 0;
                        }
                        else {
                           print('  </Td>'."\n".'  <Td>'."\n");
                        }
                     }
                  $count++;
            }            // end while
         } // end IF

         print("\n".'  </Td></Tr>'."\n".' </Table>'."\n".' </TD></TR>'."\n".'</TABLE>'."\n");
         ppm_rem('ThumbsTable END');

            if (is_array($ThumbErr)) {
               ppm_error(implode('<br>',$ThumbErr));
            }
            if ($miss!=0&&$ppmGal['msg_tn_missing']) { // some thumbnails are missing
               if ($ThumbErrNoRoot!='OK') { // error while creating the thumbs
                  ppm_error($ThumbErrNoRoot);
               }
               ppm_error($miss.' '._MODpTHUMBS.' '._MODpMISSING);
            }
      }
      elseif (($NbImages==0) && ($TRT >= 2)) {
         ppm_error(_MODpGALLERY.' ['.$lib_gal.'] '._MODpEMPTY);
      }
    $screen='gal';
  } // end if

   /* galeries list of $cat */
   if ($TRT > 1) {
      $gal_array = ppm_get_dirs(PPM_REL_DIR.'/'.$cat);
        if ($dirCount > 0) {
           if (!isset($gal)) {
              if($ppmCat['info']) {
                 $lib_gallery = _MODpGALLERIES;
                 if ($dirCount == 1) {
                    $lib_gallery = _MODpGALLERY;
                 }
                 $ppm_catinfo = ucfirst(_MODpCATEGORY).' '.ppm_rep_str($cat).' - '.$dirCount.' '
                               .$lib_gallery.'<br>';
              }
              ppm_message($ppm_catinfo);
              if($ppmText) {
                 $ppm_cat_text = ppm_get_text('/'.$cat,'ppm_text');
              }
              if(($ppm_catinfo)&&($ppm_cat_text)) {
                 print('<br>');
              }
              ppm_message($ppm_cat_text);
              ppm_rem('Gal MainTable BEGIN');
              print("\n".'<TABLE border="0" cellspacing="10" align="center" summary="Gal MainTable">'."\n"
                   .'<TR>'."\n".'<TD align="center">'."\n");
              print(' <Table width="1%" border="0" cellspacing="10" cellpadding="0" align="center"'
                   .' summary="Gal SecondTable">'."\n".'  <Tr><Td align="center">');
              $gal_columns = ppm_cols(count($galtab),$ppmMaxCols);
              $break = $gal_columns-1;
                 for ($i = 0; $i < $dirCount; $i++) {
                    print ppm_tn_cell($i,$cat,$galtab[$i],$tn_array[$i],$tn_count[$i],$ppmCat['gal_img_count']);
                       if ($i == $break) {
                          print('  </Td></Tr>'."\n".' </Table>'."\n");
                          print(' <Table width="1%" border="0" cellspacing="16" cellpadding="0"'
                               .' align="center" summary="Gal SecondTableNext">'."\n");
                          print('  <Tr><Td align="center">'."\n");
                          $break = $i + $gal_columns;
                        }
                        else {
                           print('  </Td>'."\n".'  <Td>'."\n");
                        }
                 }
              print("\n".'  </Td></Tr>'."\n".' </Table>'."\n".' </TD></TR>'."\n".'</TABLE>'."\n");
              ppm_rem('Gal MainTable END');
              $screen='cat';
           }
           elseif($screen=='pic') {    // Galleries links under a picture
              if($ppmPic['gal_links']) ppm_print_gal_links($gal_array);
           }
           elseif($ppmGal['gal_links']) {   // Galleries links the current gallery screen
              ppm_print_gal_links($gal_array);
           }
           print("\n");
        }
        elseif ($NbImages == 0) {
           ppm_error(_MODpCATEGORY.' ['.$lib_cat.'] '._MODpEMPTY);
        }
   }
   /////// categories list //////
   elseif ($catCount > 0) {
      if($ppmText) {
         $ppm_home_text = ppm_get_text('','ppm_text');
      }
      if (!isset($cat)) {
                  ppm_message($ppm_home_text);
      }
      print("\n".'<Table align="center" summary="cat list" width="'.$ppmMain['table_width']
                .'"><Tr align="center"><Td>'."\n");
      if($ppmMain['info']) {
         $lib_categ = _MODpCATEGORIES;
         if ($dirCount == 1) {
            $lib_categ = _MODpCATEGORY;
         }
         print('<br>'.$catCount.' '.$lib_categ."<br>\n");
      }
      print("<br>\n");
      ppm_display_cats($cat_array);
      print("<br><br>\n</Td></Tr></Table>\n");
      $screen='main';
   }
   elseif ($TRT!=0) {
      ppm_error(_MODpMAINPICDIR.' '._MODpEMPTY);
   }
   else {
      ppm_error(_MODpMAINPICDIR.' '._MODpNOTFOUND);
   }

   if($ppmCopy['active']) {
      print('<center><small><i>'._MODpCOPYLINE.'</i></small></center>');
   }

   if(PPMDBG) print('<div align="right"><big><b>'.$screen.'</b> screen</big></div>');

print('<br>'."\n");

if(isset($info)) ppm_info(); // Comment this line if you want...

print("\n".'<div align="right">'."\n");
print('<a '.$ppm_class_link_s.'href="http://pixfr.com" target="blank"><br><i>'._MODpPOWEREDBY.' PiXfr Photo Module '
     .PPM_VERSION.'</i></a>');
print("\n".'</div>'."\n");

CloseTable();
?>
