<?php
/*****************************************************************************
 PiXfr Photo Module (PPM)  Version 1.1.1
 Photo galleries generator
 -----------------------------------------------------------------------------
 PPM functions file
 -----------------------------------------------------------------------------
 Copyright (c) 2000,2001 by Yann Courtaux (pixman@pixfr.com)
 http://pixfr.com

 This program is free software.
 You can redistribute it and/or modify it under the terms of the GNU General
 Public License as published by the Free Software Foundation.

 This program is distributed in the hope that it will be useful, but WITHOUT
 ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details
 (attached file LICENSE).
******************************************************************************/

/*  Generate ThumbNails from image files .jpg, .png or .gif */
function ppm_do_thumb($name,$th_name,$th_height) {
    global $ppmGd;
    $im = '';
    $data = @GetImageSize($name,$info);
    if($data==NULL) {
       $result = _MODpREADERROR;
    } elseif(!extension_loaded('gd')) {
       $result = _MODpGDNOTPRESENT;
    } else {
       switch ($data[2])  // open permission needed
       {   case 1: $imgtype = 'GIF';
                   $im = @imagecreatefromgif($name); break; // GIF
           case 2: $imgtype = 'JPEG';
                   $im = @imagecreatefromjpeg($name); break; // JPG
           case 3: $imgtype = 'PNG';
                   $im = @imagecreatefrompng($name); break;  // PNG
       }
       if ($im == '')
       {   $result = $imgtype.' '._MODpFORMATNOTSUPPORTED; }
       else
       {   $w=ImageSX($im);
           $h=ImageSY($im);
           $nw=round($w * $th_height / $h);
           $nh=$th_height;
           if ($ppmGd['version2']) {       // GD 2.0 or up
              $ni = ImageCreateTrueColor($nw,$nh);
              ImageCopyResampled($ni,$im,0,0,0,0,$nw,$nh,$w,$h);
           }
           else {                           // GD version < 2
              $ni=ImageCreate($nw,$nh);
              ImageCopyResized($ni,$im,0,0,0,0,$nw,$nh,$w,$h);
           }
           ImageDestroy($im);
           switch ($imgtype)    // // write permission needed
           {   case  'GIF': ImageGif($ni,$th_name);                       break;
               case 'JPEG': ImageJpeg($ni,$th_name,$ppmGd['jpegcomp']); break;
               case  'PNG': ImagePng($ni,$th_name);                       break;
           }
           ImageDestroy($ni);
       $result = 'OK';
       }
    }
return $result;
}

/*  Build a sorted array with sub-dirs of $dir */
function ppm_get_dirs($dir='.')
{  global $dirCount, $ppmDirOut;
   if ( is_dir($dir) )
   {  $h = opendir($dir);
          while ($d = readdir($h))
          { clearstatcache();
                if($d != '.' && $d != '..' && !ereg($ppmDirOut.'|NS-',$d) && is_dir($dir.'/'.$d))
                   {   $dir_array[] = $d;
                   }
          } closedir($h);
            if (is_array($dir_array))
            {  $dirCount = count($dir_array);
               sort($dir_array);
               Return $dir_array;
            }
            else $dirCount = -1;
    }
}

/*  Build a sorted array with .$ext files present in $dir */
function ppm_get_images($dir, $ext)
{   global $fileCount, $images;
       $h = @opendir($dir);
       $fileCount = 0;
           while ( $file = readdir($h))
           {    if( (!is_dir($file)) and (!empty($file)) )
                   if(eregi(".\.($ext)$",$file))
                   {  $fileList[$fileCount] = $file;
                      $fileCount++;
                   }
           }
       closedir($h);
       if (is_array($fileList))
       {   sort($fileList);
           {  while (list($key, $filename) = each($fileList) )
                 $images[] = $filename;
           }
      }
}

/* String replacement for output text */
function ppm_rep_str($string)
{ $s = eregi_replace('../','',$string);
  $s = eregi_replace('_',' ',$s);
  $s = eregi_replace('(\.[a-z]{3,4})$','',$s);
  return $s;
}

/* Security : check for ., \ and / in the passed vars */
function ppm_check_var($variable)
{ if(ereg("[\/]",$variable)) return false;
    elseif(ereg("^\.",$variable)) return false;
      else return true;
}

/* Get the description text files 'ppm_text.php' */
function ppm_get_text($dir,$file)
{  global $lang;
   $f = PPM_REL_DIR.$dir.'/'.$file.PPM_EXT;
   if(file_exists($f)) {
      include($f);
      $text = ${'ppmt_'.$lang};
      return $text;
   }
   else return false;
}

/* Build the categories layout and links */
function ppm_display_cats($SortedArray)
{  global $ppmColor, $ppmMain;
   $disp = $ppmMain['disposition'];
   if(is_array($SortedArray))
   {   $count = count($SortedArray);
       // get icons
       $imgdir  = MOD_IMG_DIR.'/ppm';
       $imgsub  = '/'.$ppmColor['back'].'/'.$ppmColor['icon'];
       if(!file_exists($imgdir.$imgsub)) {  // default grey icons
          $imgsub = '';
       }
       $imgdir = $imgdir.$imgsub;
       $imgdef = '';
       if(file_exists($imgdir.'/cat.gif')) {
          $imgdef = "\n".'<img align="absmiddle" src="'.$imgdir.'/cat.gif" border="0" align="absmiddle" alt="'._MODpCATEGORY.'">';
       }

       for ($i = 0; $i < $count; $i++)
       {   $cati = $SortedArray[$i];
           $link = '<a href="'.PPMF.PPMVAR.'cat='.$cati;
           $text = '';
           $wrap = ' nowrap';
           $CatImg = ppm_get_thumb(PPM_REL_DIR.'/'.$cati,1);
           if($ppmMain['cat_text']) {
              $text = ppm_get_text('/'.$cati,'ppm_main_text');
              if($text>'  ') {
                 $wrap = '';
                 $text = '<br>'.$text;
              }
           }
           if($ppmMain['gal_count']) {
              $nbr  = ' ('.count(ppm_get_dirs(PPM_REL_DIR.'/'.$cati)).')';
           }
           if($CatImg!='no_tn_found'&&$ppmMain['thumb']) {
              $img = "\n".'<img src="'.PPM_REL_DIR.'/'.$cati.'/'.$CatImg.'" border="0" align="absmiddle" alt="'
                     .ppm_rep_str($cati).'">';
           } else {
              $img = $imgdef;
           }
           $td_img = '<td valign="middle"';
           if(($disp=='left')||( ($disp=='mix') && (($i/2) == ceil($i/2)) ) ) {
              $arr[] = "\n".'<table cellspacing="3" cellpadding="3" border="0"><tr><td>'.$link.'">'.$img.'</a>'
                      ."\n".'</td>'.$td_img.$wrap.'>'.$link.'">'
                      .ppm_rep_str($cati).$nbr.'</a>'.$text."</td>\n</tr></table>\n";
           } elseif(($disp=='right')||( ($disp=='mix') && (($i/2) != ceil($i/2)) ) ) {
               $arr[] = "\n".'<table cellspacing="3" border="0"><tr>'.$td_img.' align="right"'.$wrap.'>'
                       .$link.'">'.ppm_rep_str($cati).$nbr.'</a>'.$text."</td>\n"
                       .'<td>'.$link.'">'.$img.'</a>'."\n</td>\n</tr></table>\n";
           } else { /* if wrong parameters, initialise with default values */
               $disp = 'mix';
               $i -= 1;
           }
       }

       if(is_array($arr)) {
          OpenTable();
          if(1!=1) {
            $table_open = OpenTable();
            $table_close = CloseTable();
          } else {
            $table_open = '';
            $table_close = '';
          }
          $count = 1;
          $break = $ppmMain['cat_cols'];
          $td = '<TD align="'.$ppmMain['cat_align'].'">';
          print("\n".'<TABLE align="center" border="0" cellpadding="0" cellspacing="2"><TR>'.$td."\n");
             while (list ($key, $val) = each ($arr))
             {  //OpenTable();
                print($table_open.$arr[$key].$table_close);
                //CloseTable();
                if($count == $break)
                {  print('  </TD></TR>'."\n".' <TR>'.$td."\n");
                   $break = $count + $ppmMain['cat_cols'];
                   $TotalWidth = 0;
                }
                else {
                   print('  </TD>'."\n".'  <TD>'.$td."\n");
                }
             $count++;
             }
          print("\n</TD></TR></TABLE>\n\n");
          CloseTable();
       }
   }
   else return -1;
}

/* Build arrays of navigation links needed by PPM */
function ppm_do_links($SortedArray, $type)
{  global $cat, $gal, $pic, $ppmColor;
   // get icons
   $imgdir  = MOD_IMG_DIR.'/ppm';
   $imgsub  = '/'.$ppmColor['back'].'/'.$ppmColor['icon'];
   if(!file_exists($imgdir.$imgsub)) {  // default grey icons
      $imgsub = '';
   }
   $imgdir = $imgdir.$imgsub;
   if(is_array($SortedArray))
   {   $count = count($SortedArray);
    // Next and Prev links
       if ((file_exists($imgdir.'/prev.gif'))&&(file_exists($imgdir.'/next.gif')))
       {   $NxtPrv = True;
           $Next = ''; $Prev = '';  }
       else
       {   $NxtPrv = False;         }
    // Navigation links
       $link = ' <a href="'.PPMF.PPMVAR.'cat=';
         if($type=='gal')
         {   $link .= $cat.'&amp;gal=';}
         elseif($type=='pic')
             {   $link .= $cat.'&amp;gal='.$gal.'&amp;pic=';}
    // type = img OR gal, AND more than one element
           while (list ($key, $val) = each ($SortedArray))
           {   // Prev link + Current link + Next link
               if($val==$$type)
                {  if($key != 0)
                   {  if(!$NxtPrv)
                      {   $prev = '['.$link.$SortedArray[($key-1)].'">'._MODpPREV.'</a> ] ';}
                      else
                      {   $prev = $link.$SortedArray[($key-1)].'"><img src="'.$imgdir.'/prev.gif" border="0"'
                                 .' align="top" alt="'._MODpPREV.'"></a>';}
                   }
                   if($type=='pic')
                   {  $CurImg = _MODpPICTURE.' '.($key+1).' '._MODpOF.' '.$count; }
                   else $CurImg = ppm_rep_str($SortedArray[$key]);

                   $arr[] = '<b><i>'.$CurImg.'</i></b>';

                   if($key != $count-1)
                   {  if(!$NxtPrv)
                      {   $next = ' ['.$link.$SortedArray[($key+1)].'">'._MODpNEXT.'</a> ]';}
                      else
                      {   $next = $link.$SortedArray[($key+1)].'"><img src="'.$imgdir.'/next.gif" border="0"'
                                 .' align="top" alt="'._MODpNEXT.'"></a>';}
                   }
                }
                elseif ($type=='gal')
                    { $arr[] = $link.$SortedArray[$key].'">'.ppm_rep_str($SortedArray[$key]).'</a>';}
           print('');
           }
   $ResultArray[]=$prev;
   if(is_array($arr))
     while (list ($key, $val) = each ($arr))
     {  $ResultArray[]=$a.$arr[$key];   }
   $ResultArray[]=$next;
   print(implode("\n &nbsp; ", $ResultArray));
   }
   else return -1;
}

function ppm_print_gal_links($arr)
{ print("\n".ppm_rem('GalLinksTable BEGIN').'<table border="0" cellspacing="16" align="center"'
            .' summary="Links Gal Table">'."\n".'<tr>'."\n".'<td align="center">'."\n");
  ppm_do_links($arr, 'gal');
  print("</td>\n</tr>\n</table>\n");
  ppm_rem('GalLinksTable END');
}

/* Pick a thumbnail in $dir according to $type value */
function ppm_get_thumb($dir,$type)
{  global $TNCount;
   $array[0] = 'no_tn_found';
   $h = opendir($dir);
   $i = 0;
   while ( $file = readdir($h))
   {    if( (!is_dir($dir.'/'.$file))&&(!empty($file))  )
             if(eregi("(-ppm)$",$dir.'/'.$file))
             {  $array[$i] = $file;
                $i++;
             }
   }
   closedir($h);

   if($i>0) {
     $TNCount = count($array);
   } else {
     $TNCount = 0;
   }
   if ($type == 1)     // random TN
   {   srand ((double)microtime()*1000000);
       shuffle ($array);
   }
   else sort($array);  // first TN in alphabetical order

return $array[0];
}

/* displays a formated cell containing the TN linking to a $gal of $cat */
function ppm_tn_cell($position=1,$cat,$gal,$tname,$tncount,$imgcount)
{ global $ppmGd, $ppm_img_count, $ppmCat;
  $Start = '  <table align="center" width="1%" summary="ThumbCell">'."\n";
  if(ereg('no_tn_found',$tname))
    if($ppmGd['generate']) $tn = '[ '._MODpCREATETN.' ]';
    else $tn = _MODpPICTURESNOTFOUND;
  else $tn = '<img src="'.PPM_REL_DIR.'/'.$cat.'/'.$gal.'/'.$tname.'" border="0" alt="'.$gal.'">';
  if($imgcount) $count = ' ('.$tncount.')';
  $Img   = '    <tr><td align="center"><a href="'.PPMF.PPMVAR.'cat='.$cat.'&amp;gal='.$gal
          .'">'.$tn.'</a></td></tr>'."\n";
  $Name  = '    <tr><td align="center"><a href="'.PPMF.PPMVAR.'cat='.$cat.'&amp;gal='.$gal
          .'">'.ppm_rep_str($gal).$count.'</a></td></tr>'."\n";
  $End  =  '  </table>'."\n";

  if($ppmCat['thumb_layout']!='mix') {
      if($ppmCat['thumb_layout']=='top') {
          return ($Start . $Name .$Img . $End);
      } else {
          return ($Start . $Img . $Name . $End);
      }
  } else {
      if(floor($position/2) == ceil($position/2)) {
          return ($Start . $Img . $Name . $End);
      } else {
          return ($Start . $Name . $Img . $End);
      }
  }
}

/* Enhances the distribution of table elements */
function ppm_cols($elements,$maxcols)
{ if($elements <= $maxcols)
  { return $maxcols; }
  else
  { $fullrows = floor($elements/$maxcols);
    $reste = $elements - ($fullrows*$maxcols);
    if($reste==0)
    { return $maxcols;}
    else
    { $fulltable = ($fullrows+1)*($maxcols-1);
      if($elements == $fulltable)
      {  return ($maxcols-1);  }
      elseif($elements > $fulltable)
      {  return $maxcols; }
      else
      { $res = ppm_cols($elements,($maxcols-1));
        return $res;
      }
    }
  }
}

/* return FALSE when NO Write-Execute permissions on $dir */
function ppm_root($dir)
{  $result   = true;
   $perm = decoct(fileperms($dir));
   if(PPMDBG) print('PERM:'.$perm);
   if(!ereg('777',$perm)) {
         $result = false;
   }
   return $result;
}

/* print formated message */
function ppm_message($msg)
{ if($msg!='') {
    OpenTable2();
    print('<div align="center"><b>'.$msg.'</b></div>');
    CloseTable2();
  }
}

/* print formated Error messages */
function ppm_error($msg)
{ global $adminmail;
  print('<br><br>');
   ppm_message('<a href="http://pixfr.com">PiXfr Photo Module (PPM) version '.PPM_VERSION.'</a><br><br><big>'
               .$msg.'</big><br><br>'._MODpPLEASECONTACT.'<a href="mailto:'.$adminmail.'"> webmaster</a>');
  print('<br><br>');
}

/* print some infos */
function ppm_info()
{  global $Version_Num;
   ppm_message('<a href="http://pixfr.com">PiXfr Photo Module (PPM) version '.PPM_VERSION
              .'</a><br>Copyright &copy; 2001 Yann Courtaux<br>PPM is a free software under the GPL terms');
   print('<br>'."\n");
   // Is GD runing ?
   if(!extension_loaded('gd')) {
     $gd_info = ' NOT ';
   }
   $gd_info = 'GD LIBRARY '.$gd_info.'INSTALLED';

   $ppm_nuke = PPM_NUKE.' '.$Version_Num;
   ppm_message('PHP '.PHP_VERSION.' running on '.PHP_OS.'<br>'.$gd_info.'<br>'.$ppm_nuke);
   print('<br>'."\n");
}

/* A debug thing */
function ppm_rem($rem)
{ print("\n".'<!-- PPM '.$rem.' -->'."\n");
}
?>
